/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */

    function onInitComponent(oComponent){

        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");

        onInitMainframeComponent(oComponent);

        //Set default values using Publish/Subscribe pattern
        oComponent.addParamVal("name",_D("Area Light Controller")+" "+oComponent.UId);

        //Select default Gui gateway
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);

        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();

        /** drop down parameters of this widget **/



        /** ABILITARE I COMMENTI PER AGIUNGERE ICONA
         *
         */

        //var oIcon_status_1 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();

        var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

        var i0=model["instance"].skin.ComponentsInfo.AreaLightController.defaultIcons[0];

        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });

        //Important: maintain original position
        aIcons.push(oIcon_status_0);
        //aIcons.push(oIcon_status_1);

        oComponent.addParamVal("viewmodelist",[
            {id:0, label:"Classic"}
            //,{id:1, label:"Modal"}
            //,{id:2, label:"Only Text"}
            //,{id:3, label:"Hidden"}
        ]);

        // Components
        // BEGIN MUST BE ALWAYS EXIST
        oComponent.addParamVal("gui/components-list","");

        oComponent.addParamVal("gui/components", new Array() );
        // END MUST BE ALWAYS EXIST
/*
        oComponent.addParamVal("value",0);

        // GUI
        oComponent.addParamVal("gui",new Object());
        oComponent.addParamVal("gui/virtual-feedback",true);
        oComponent.addParamVal("gui/userdata","");
        oComponent.addParamVal("gui/data","");

        oComponent.addParamVal("gui/torrini_tempo_riarmo","360");
        oComponent.addParamVal("gui/torrini_temperatura","30");


        oComponent.addParamVal("gui/elenco_componenti","");

        oComponent.addParamVal("gui/lamps1","");
        oComponent.addParamVal("gui/lamps2","");
        oComponent.addParamVal("gui/night_lamps","");

        oComponent.addParamVal("gui/manuale","60");
        oComponent.addParamVal("gui/sensorReleaseTime","10");

        oComponent.addParamVal("gui/level1","50");
        oComponent.addParamVal("gui/level2","70");
        oComponent.addParamVal("gui/level_night","20");

        oComponent.addParamVal("gui/permanenza_chiusura_lucernari","");
        oComponent.addParamVal("gui/riarmo_automatico","");


*/
        // Ghost
        oComponent.addParamVal("ghost",new Object());
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");
        oComponent.addParamVal("ghost/data","");
        oComponent.addParamVal("EVEUIStyle","onlyMap");

    };
}
catch(err){
    console.error(err);
}
