/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        //console.log(oComponent);
        onInitMainframeComponent(oComponent);
        
        //Set default values
        oComponent.addParamVal("name",_D("Email")+" "+oComponent.UId);
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);

        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();

        var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

        var i0=model["instance"].skin.ComponentsInfo.SendEmail.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });

        //Important: mantain original position
        aIcons.push(oIcon_status_0);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		,{id:3, label:"Hidden"} 
        	]);
        
        oComponent.addParamVal("value",0);
        

        
        // Ghost
        oComponent.addParamVal("ghost",new Object());
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");
        oComponent.addParamVal("ghost/data","");

        oComponent.addParamVal("EVEUIStyle","onlyMap");


    };
}
catch(err){
    console.error(err);
}
