/** Icon class
 * 
 * @class Icon
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function Icon(){
	var self = this;

    var init = function () {
        // Set Default logout Icon

        var defaultMap=model["instance"].skin.IconsPan;

        self.size.h = defaultMap.iconsWidth;
        self.size.w = defaultMap.iconsWidth;
        self.setSize.h = defaultMap.imgWidth;
        self.setSize.w = defaultMap.imgHeight;

        self.iconsPanId=model["instance"].skin.IconsPan[0].id; // setta di default la prima mappa delle icone
        self.iconsPanId=model["instance"].skin.IconsPan[0].id;
    };

    this.iconsPanId;
	/** Icon image source
     * @public
     * @type string
     * @default "./css/icons-set/images/icons-state_1-128x128.png"
     */
    //this.src = "../project/assest/icons/icons-state_1-128x128.png";
    this.srcId;
	
	/** Icon image position
	 * @public
	 * @type object
	 * @default { x:0, y:0 }
	 */
	this.position = {
	    x:0,
	    y:0
	};
	
	/** Icon color (white)
	 * @public
	 * @type object
	 * @default { R:255, G:255, B:255, }
	 */
	this.color = {
        R:255,
        G:255,
        B:255
    };
    
    /** Icon size (white)
     * @public
     * @type object
     * @default { h:102, w:100 }
     */
    this.size = {
        h:102,
        w:100
    };
    
    /** Icons set size
     * @public
     * @type object
     * @default { h:2048, w:2048 }
     */
    this.setSize = {
        h:2048,
        w:2048
    };
    
    /** Icon scale factor
     * @public
     * @type Number
     * @default 1
     */
    this.scaleFactor = 1;
    
    /** Icon colors enabled
     * @public
     * @type boolean
     * @default false
     */
    this.enableColors = false;

    init();
}