/** iconEditor class (extends Window class)
 *
 * @class iconEditor
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function yearEditor(oWindow){
	
	var self = this;

    var selectionState=0;


    function getvalueArray(day,month,year)
    {

        var pos=0;
        while (pos<valueArrayYear.length)
        {
            if (valueArrayYear[pos]==year)
            {
                return valueArrayYear[pos+month*31+(day-1)+1]; // i giorni partono da 1
            }
            pos+=31*12+1;
        }
        setvalueArray(day,month,year,0);
        return 0;
    }

    function setvalueArray(day,month,year,value)
    {

        var pos=0;
        console.log(valueArrayYear);
        console.log(valueArrayYear.length);
        while (pos<valueArrayYear.length)
        {
            if (valueArrayYear[pos]==year)
            {
                pos++; // posiziona il puntatore all'indice successivo all'anno
                console.log("year found");
                valueArrayYear[pos+month*31+(day-1)]=value; // i giorni partono da 1
             //   console.log("Y SET VALUE AT "+pos+(month-1)*31+day+1+" TO "+value);
                return 0;
            }
            pos+=31*12+1;// mesi x 31 + 1 dell'anno
            console.log(pos);
            console.log("year "+year+" not found");

        }

        // se l'anno non esiste lo inizializza e setta nuovamente
        valueArrayYear[pos]=year;
        pos++;
        for (var kk=0;kk<31*12;kk++)
        {
            valueArrayYear[pos+kk]=0;
        }
        setvalueArray(day,month,year,value)

      //  console.log("SET VALUE AT "+pos+(month-1)*31+day+1+" TO "+value);
        return pos;
    }


	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - iconEditor class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            height: "auto",
            width: "auto",
            autoOpen: false,
            modal: true,
            resizable: false,
            close: m_oWindow.hide,
            title: _D("Year Editor"),
            create: function(e,ui){
                $(this).find(".actions button").button();
            }
        });
        
        //On enable/disable color
        m_$element.on("change",".enableColors",self._colorEnabling);

        //On Submit
        m_$element.on("submit","form",self._submit);
        
        //On reset
        m_$element.on("click",".actions [type='reset']",function(e){
            m_oWindow.hide();
        });

        var drawing = $(".yearTime").css({
            overflow: 'hidden',
            border: '0px solid #000000',
            width: 1200
        });

        $('<canvas class="YearCanvas" width="'+1200+'" height="'+320+'" style="cursor: auto;"  >').appendTo(drawing);
        $( "#yearEditorradio" ).buttonset();

        backGround.src = "../html/assets/img/weekTimeBackground.png";
        backGround.addEventListener('load', eventSheetLoaded , false);
        $(".YearCanvas").mousemove(function(event){

            if (event.which==1) // mouse down
            {

              /*  $(".YearCanvas").drawRect({
                    draggable: false,
                    fillStyle: "#000000",
                    x: 1000,
                    y: 250,
                    width:100,
                    height:20
                });
                */
                //console.log($("#weekEditorradio1")[0].checked);
                var zzz=(event.offsetX-123);
                if (zzz<0) return;
                if (zzz>24*31) return;

                zzz=(event.offsetY-21);
                if (zzz<0) return;
                if (zzz>24*12) return;


                //console.log(downX);
                //console.log(downY);

                var x =parseInt((event.offsetX-123)/24);
                var y =parseInt((event.offsetY-20)/24);

                y=y+1; // i mesi partono da 1 , i giorni da 0;

                var lastDayOfMonth = new Date(selectedYear, y, 0);
                console.log(lastDayOfMonth);

                if (x<lastDayOfMonth.getDate())
                {

              /*      $('.YearCanvas').drawText({
                        fillStyle: '#ffffff',
                        strokeStyle: '#ffffff',
                        strokeWidth: 0,
                        x: 1000, y: 250,
                        fontSize: 12,
                        fontFamily: 'Verdana, sans-serif',
                        text:x+" "+y// daysNames[i % daysNames.length]
                    });*/
                }
            }

         /*   $(".YearCanvas").drawRect({
                draggable: false,
                fillStyle: "#000000",
                x: 1100,
                y: 300,
                width:100,
                height:20
            });
            $('.YearCanvas').drawText({
                fillStyle: '#ffffff',
                strokeStyle: '#ffffff',
                strokeWidth: 0,
                x: 1100, y: 300,
                fontSize: 12,
                fontFamily: 'Verdana, sans-serif',
                text:event.offsetX+" "+event.offsetY// daysNames[i % daysNames.length]
            });

*/

        });

        $(".WeekCanvas").mouseup(function(event){


        });

        var executeDown=false;
        $(".YearCanvas").mousedown(function(event){



            // check up down
            var xxx=(event.offsetX);
            var yyy=(event.offsetY);
            if (xxx>1020 && xxx<1043 )
            {
                if (yyy>233 && yyy<255)
                {
                    // up clicked
                    selectedYear++;
                    refreshBackGround();
                    executeDown=false;
                    return;
                }
                if (yyy>290 && yyy<311)
                {
                    // down clicked
                    var dd=new Date();
                    if (selectedYear> dd.getFullYear())
                    {
                        selectedYear--;
                        refreshBackGround();
                        executeDown=false;
                    }
                    return;
                }


            }

            var xxx=(event.offsetX-123);
            var yyy=(event.offsetY-21);

            // check day/month
            if (xxx<0)
            {
                executeDown=false;
                return;
            }
            if (xxx>24*32) {
                executeDown=false;
                return;
            }


            if (yyy<0) {
                executeDown=false;
                return;
            }
            if (yyy>24*12) {
                executeDown=false;
                return;
            }


            //console.log(downX);
            //console.log(downY);

            var selectedDay =parseInt((event.offsetX-123)/24);// i giorni partono da 1 i mesi da 0
            var selectedMonth =parseInt((event.offsetY-20)/24);

            var lastDayOfMonth = new Date(selectedYear, selectedMonth+1, 0);
            console.log(lastDayOfMonth);

            console.log(selectedDay+" "+selectedMonth);


            if (selectedDay<=lastDayOfMonth.getDate())
            {
          /*      $(".YearCanvas").drawRect({
                    draggable: false,
                    fillStyle: "#000000",
                    x: 1000,
                    y: 250,
                    width:100,
                    height:20
                });
                $('.YearCanvas').drawText({
                    fillStyle: '#ffffff',
                    strokeStyle: '#ffffff',
                    strokeWidth: 0,
                    x: 1000, y: 250,
                    fontSize: 12,
                    fontFamily: 'Verdana, sans-serif',
                    text:selectedDay+" "+selectedMonth// daysNames[i % daysNames.length]
                });
*/
                var todayDay= new Date(selectedYear, selectedMonth, selectedDay);
                var weekDay = todayDay.getDay();
                var dayval=getvalueArray(selectedDay,selectedMonth,selectedYear);
                if (dayval==0)
                {
                    setvalueArray(selectedDay,selectedMonth,selectedYear,1);
                }
                else if (dayval==1)
                {
                    setvalueArray(selectedDay,selectedMonth,selectedYear,2);
                }
                else if (dayval==2)
                {
                    setvalueArray(selectedDay,selectedMonth,selectedYear,3);
                }
                else if (dayval==3)
                {
                    setvalueArray(selectedDay,selectedMonth,selectedYear,0);
                }
                refreshBackGround();
                executeDown=false;
            }
        });
    };

    // REGION  variables
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element = oWindow;
    
    /** Edited icon
     * @type {object}
     */
    var m_oIcon;

    // l'array prevede un valore iniziale che rappresenta l'anno , 12*31 giorni e 10 anni
    // se l'anno =0 indica che non è stato settato
    // quando si setta qualcosa si cerca se l'anno esite, se non esiste si crea, eventualmente rimuovendo gli anni vecchi

    var valueArrayYear= [];
    var valueYear= [];


    var colors=[
        "#535353", // normale
        "#FC4C36", // speciale
        "#E0BB56", // chiusura
        "#64A34E", // festivo
        "#56D3E0", // sabato
        "#955DFC"  // domenica
    ];
    var unitSize = 24; // width (and height) of one square
    var unitsWide = 24; // number of squares along x-axis
    var unitsTall = 7; // number of squares along y-axis

    var backGround = new Image();
    var dd=new Date();
    var selectedYear= dd.getFullYear();

    // END REGION variables



    function refreshBackGround()
    {
        var d = new Date();
        var n = d.getDay();

        // remove 29/02
        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: "#000000",
            x: 29*24 + 131, y: 1*24 + 29,
            width: 24, height: 24
        });


        var month=0;
        for (var dy=0;dy<12;dy++)
        {
            var startDay=new Date(selectedYear,dy,1);
            var n = startDay.getDay();
            // console.log(n);
            var lastDayOfMonth = new Date(selectedYear, dy+1, 0);
            // console.log(lastDayOfMonth);
            for (var dx=1;dx<=31;dx++) {
                //if ((dx-n+1>0) && (dx-n<lastDayOfMonth.getDate()))
                if (dx<=lastDayOfMonth.getDate())
                {
                    var dayX = new Date(selectedYear, dy, dx);
                    var n1 = dayX.getDay();
                    //  console.log(n1+" "+dayX);
                    var dayVal=getvalueArray(dx,dy,selectedYear);
                    if (dayVal==0)
                    {
                        if (n1==6)
                        {
                            $(".YearCanvas").drawRect({

                                draggable: false,
                                fillStyle: colors[4],
                                x: dx*24 + 131, y: dy*24 + 29,
                                width: unitSize - 2, height: unitSize - 2
                            });
                        }
                        if (n1==0)
                        {
                            $(".YearCanvas").drawRect({

                                draggable: false,
                                fillStyle: colors[5],
                                x: dx*24 + 131, y: dy*24 + 29,
                                width: unitSize - 2, height: unitSize - 2
                            });
                        }
                        if (n1>=1 && n1<6 )
                        {
                            $(".YearCanvas").drawRect({

                                index: 0,
                                draggable: false,
                                fillStyle: colors[0],
                                x: dx*24 + 131, y: dy*24 + 29,
                                width: unitSize - 2, height: unitSize - 2
                            });

                        }

                    }
                    if (dayVal==1)
                    {
                        $(".YearCanvas").drawRect({

                            index: 0,
                            draggable: false,
                            fillStyle: colors[1],
                            x: dx*24 + 131, y: dy*24 + 29,
                            width: unitSize - 2, height: unitSize - 2
                        });

                    }
                    if (dayVal==2)
                    {
                        $(".YearCanvas").drawRect({

                            index: 0,
                            draggable: false,
                            fillStyle: colors[2],
                            x: dx*24 + 131, y: dy*24 + 29,
                            width: unitSize - 2, height: unitSize - 2
                        });

                    }
                    if (dayVal==3)
                    {
                        $(".YearCanvas").drawRect({

                            draggable: false,
                            fillStyle: colors[3],
                            x: dx*24 + 131, y: dy*24 + 29,
                            width: unitSize - 2, height: unitSize - 2
                        });

                    }

                    $('.YearCanvas').drawText({

                        fillStyle: "#ffffff",
                        strokeStyle: "#ffffff",
                        width: 24,
                        index: 0,
                        strokeWidth: 0,
                        x: dx*24+ 131, y: dy*24 + 29,
                        alpha: 0.1,
                        fontSize: 10,
                        fontFamily: 'Verdana, sans-serif',
                        text: dx
                    });

                }
            }
        }
        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: "#000000",
            x: 1030, y: 270,
            width: 100, height: 20
        });

        $('.YearCanvas').drawText({
            fillStyle: "#ffffff",
            strokeStyle: "#ffffff",
            width: 24,
            strokeWidth: 0,
            x: 1030, y: 270,
            alpha: 0.1,
            fontSize: 18,
            fontFamily: 'Verdana, sans-serif',
            text: selectedYear
        });

    }
	
	/** Show icon editor window
	 */
	this.show = function(oParam){
        valueArrayYear= [];
        var dd=new Date();
        selectedYear= dd.getFullYear();
	    var oNode = m_oWindow.getActiveNode();
	    var oData;
        if (oNode!=null)
        {
            oData=oNode.getData();
            //console.log(oNode);


            var timing=oData.getParamVal("gui/data");
            var pos=0;
            var arrIndex=0;
            while (pos<timing.length)
            {
                var y=timing.substring(pos,pos+4);
                valueArrayYear[arrIndex]=y;
                pos+=3;
                for (var i=0;i<12*31;i++)
                {
                    pos++;
                    arrIndex++;

                    valueArrayYear[arrIndex]=timing.substring(pos,pos+1);


                }
                pos++;
                arrIndex++;
            }
        }

        refreshBackGround();

        m_$element.dialog("open");

	};

    function eventSheetLoaded() {


        var context = $('.YearCanvas')[0].getContext("2d");
        context.drawImage(backGround, 0,0,$('.YearCanvas')[0].width,$('.YearCanvas')[0].height);

//        var texts=["January","February","March","May","June","July","August","August","September","October","November","Dicember"];
        var texts=["Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"];

        var daysNames=["L","M","M","G","V","S","D"];

/*
        for (var i =0; i < 31 ; i++) {
            $('.YearCanvas').drawText({
                fillStyle: '#ffffff',
                strokeStyle: '#ffffff',
                strokeWidth: 0,
                x: i*unitsWide+130, y: 10,
                fontSize: 12,
                fontFamily: 'Verdana, sans-serif',
                text:i+1// daysNames[i % daysNames.length]
            });
        }
*/


        for (var v = 0; v <texts.length ; v++)
        {
            $('.YearCanvas').drawText({

                fillStyle: '#ffffff',
                strokeStyle: '#ffffff',
                strokeWidth: 0,
                x: 10, y: unitsWide*v+10+10+10,
                width: 100,
                fontSize: 12,
                fontFamily: 'Verdana, sans-serif',
                align: 'left',
                respectAlign: true,
                text: texts[v]
            });
        }


        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: colors[0],
            x: 1030, y:  30,
            width: unitSize - 2, height: unitSize - 2
        });


        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: colors[1],
            x: 1030, y:  60,
            width: unitSize - 2, height: unitSize - 2
        });

        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: colors[2],
            x: 1030, y:  90,
            width: unitSize - 2, height: unitSize - 2
        });

        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: colors[3],
            x: 1030, y:  120,
            width: unitSize - 2, height: unitSize - 2
        });

        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: colors[4],
            x: 1030, y:  150,
            width: unitSize - 2, height: unitSize - 2
        });

        $(".YearCanvas").drawRect({

            draggable: false,
            fillStyle: colors[5],
            x: 1030, y:  180,
            width: unitSize - 2, height: unitSize - 2
        });

        $('.YearCanvas').drawText({

            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: 1060, y: 30,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Normale"
        });


        $('.YearCanvas').drawText({

            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: 1060, y: 60,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Speciale"
        });

        $('.YearCanvas').drawText({

            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: 1060, y: 90,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Chiusura"
        });

        $('.YearCanvas').drawText({

            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: 1060, y: 120,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Festivo"
        });

        $('.YearCanvas').drawText({

            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: 1060, y: 150,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Sabato"
        });

        $('.YearCanvas').drawText({

            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: 1060, y: 180,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Domenica"
        });


     /*   $(".YearCanvas").drawRect({
            draggable: false,
            fillStyle: "#ffffff",
            x: 1030, y:  245,
            width: unitSize - 2, height: unitSize - 2
        });
*/
        $(".YearCanvas").drawPolygon({

                fillStyle: '#ffffff',

                x: 1030, y: 245,
                radius: 12,
                sides: 3


            });

        $(".YearCanvas").drawPolygon({

            fillStyle: '#ffffff',
            x: 1030, y: 295,
            radius: 12,
            rotate: 60,
            sides: 3


        });
    /*    $(".YearCanvas").drawRect({
            draggable: false,
            fillStyle: "#ffffff",
            x: 1030, y:  295,
            width: unitSize - 2, height: unitSize - 2
        });
*/


        refreshBackGround();
    }


    /** Hide icon editor window and closing operation
	 */
	this.hide = function(e,ui){
	    m_oIcon = undefined;
	    
	    //Show hidden elements
        m_$element.find(".actions [type='button']").show();
	    
	    //Close
	    m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    

    
    /** Confirm changes
     * 
     */
    this._submit = function(e){
        var oNode = m_oWindow.getActiveNode();
        var oData;
        if (oNode!=null)
            oData = oNode.getData();
        

         if(oData instanceof Component)
         {
            var oComponent = oData;
            var ret="";
            var pos=0;
            while (pos<valueArrayYear.length)
            {
                ret+=valueArrayYear[pos];
                console.log(valueArrayYear);
                for (var i=0;i<31*12;i++)
                {
                    pos++;

                    ret=ret+valueArrayYear[pos];
                }
                pos++;

            }
            //Set model and view
            $.publish("/model/components/"+ oComponent.id +"/update/parameter",[oComponent,"gui/data",ret]);
             application.selectComponent(oNode);
         }



        //Call external window hide method
        m_oWindow.hide();
    };
}