"use strict";

/*
 <span dictionary="Color" style="margin-left: 20px; display: inline-block">&nbsp;</span>
 <input type="text" class="color" style="height:20px; width:64px; display: inline-block;" />


 */
function colorSelector(setColorFunction,divPlace, data) {

    function decimalToHex(d, padding) {
        var hex =parseInt( d).toString(16);
        padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;

        while (hex.length < padding) {
            hex = "0" + hex;
        }

        return hex;
    }

    var self = this;
    var selectedComponent = application.getSelectComponent();
    var oData = selectedComponent.getData();

    if (oData.getParamVal(data.uid) == undefined)
        if (data.default != undefined) {
            oData.addParamVal(data.uid,data.default);
        }
        else
        {
            oData.addParamVal(data.uid,"#FF0000");
        }
    var $container = divPlace;


    var $label = $('<span eve-manager-dictionary="'+data.label+'">'+data.label+'</span><br />');
    var $input = $('<input type="text" eve-manager-id="'+data.uid+'"  style="border: solid 1 rgb(255, 255, 255);border-right-color:white; height:20px; width:100px; display: inline-block;"></input><br />');

    //Append input
    //$select.addClass("widget-components");
    $input.attr("eve-manager-id",data.uid);
    //$input.attr("eve-manager-type","parameter");
    $container.append($label);
    $container.append($input);

    $($input).data('component', selectedComponent);
    $($input).data('paramID', data.uid);

    console.log(oData.getParamVal(data.uid));

    $("[eve-manager-id='"+data.uid+"']").spectrum({

        preferredFormat: "rgb",
        localStorageKey: "spectrum.homepage",
        showAlpha: true,
        showPalette: true,
      //  showInitial: true,
        palette: model.instance.getStatus().colorPresets,
        showInput: true,
        change: function(color) {
            console.log(color.toHex8());
            $(this).data().component.getData().setParamVal($(this).data().paramID,color.toHex8());

            var col=color.toHex8();
            col=col.substr(col.length - 6)+col.substring(0, 2);
            setColorFunction($(this).data().component,col,data.uid);
        }
    });

    var col1=oData.getParamVal(data.uid);
    col1="#"+col1.substring(7, 9)+col1.substring(1 ,7);
    $("[eve-manager-id='"+data.uid+"']").spectrum("set",  "#"+col1);

  /*  var val=oData.getParamVal(data.uid);
    $input.val(val.substr(1,6));
    $input.css("background-color",val);

    var hsl = $.colors(val).model('HSL').get();
    //console.log(hsl.h);

    $("[eve-manager-id='"+data.uid+"']").click(function(){
        var $colorElement = $(this);
        blr.colorPicker.onChange = function(hsb,hex,rgb,el,bySetColor){
            // $colorElement.css("background-color","#"+ hex);
            $colorElement.css('border-right-color','#'+hex);
            // Fill the text box just if the color was set using the picker, and not the colpickSetColor function.
            //if(!bySetColor)
            $colorElement.val(hex.toUpperCase());



            //self._chooseColor(hsb,hex,rgb,m_$element.find(".color")[0]);
            //Call set color function
            //setKnxColor(param,hex,hue,HTMLelem);

            setColorFunction(hsb,hex,rgb,$colorElement);
            //Change item background color
            //$(HTMLelem).css("background-color","#"+ hex);
            $colorElement.css("background-color","#"+ hex);
            var hsl = $.colors('#'+hex).model('HSL').get();
            //console.log(hsl);
            if (hsl[2]>50)
            {
                $colorElement.css("color","#000000");
            }
            else
            {
                $colorElement.css("color","#ffffff");
            }

        };
        blr.colorPicker.onClose = function(hex){
            //   var oComponent = eveManager.getSelectComponent().getData();
            //  $.publish("/model/components/"+ oComponent.id +"/update/parameter",[oComponent,'color-1',"#"+hex]);
            //   $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,'color-1']);
        };
        blr.colorPicker.show($colorElement,bigh.textRgb2hex($(this).css("background-color")));
    });
*/
    /*
    $("[eve-manager-id='"+data.uid+"']").colpick({
        onBeforeShow: function(pickerElem){
            //Background color described as "rgb(R,G,B)"
            //TODO check "bigh.textRgb2hex" function
            //console.error($(this).css("background-color"));
            //$(this).ColorPickerSetColor(bigh.textRgb2hex($(this).css("background-color")));
            //$(this).colpickSetColor(bigh.textRgb2hex($(this).css("background-color")));
            //$(this).colpickSetColor(bigh.textRgb2hex($(this).css("border-right-color")));

            //console.error(pickerElem);
            $(this).css('border-color',bigh.textRgb2hex($(this).css("background-color")));
            $(this).colpickSetColor(bigh.textRgb2hex($(this).css("border-right-color")));
        },
        //On choose color
        layout:'hex',
        //onSubmit: self._chooseColor,
        colorScheme:'dark',
        submit:false,
        //flat: true,
        //onChange: self._chooseColor
        //onChange: function(param,hex,hue){
        onChange: function(hsb,hex,rgb,el,bySetColor){



            $(el).css('border-right-color','#'+hex);
            // Fill the text box just if the color was set using the picker, and not the colpickSetColor function.
            if(!bySetColor)
                $(el).val(hex.toUpperCase());


            //self._chooseColor(hsb,hex,rgb,m_$element.find(".color")[0]);
            //Call set color function
            //setKnxColor(param,hex,hue,HTMLelem);

            setColorFunction(hsb,hex,rgb,el);
            //Change item background color
            //$(HTMLelem).css("background-color","#"+ hex);
            $(el).css("background-color","#"+ hex);
            var hsl = $.colors('#'+hex).model('HSL').get();
            console.log(hsl);
            if (hsl[2]>50)
            {
                $(el).css("color","#000000");
            }
            else
            {
                $(el).css("color","#ffffff");
            }

        }
    }).keyup(function(){
        $(this).colpickSetColor(this.value);
    });
*/

}