/**
 * Created by blr on 16/10/15.
 */
/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");

        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        //eval( QT.readFile("./components/mainframe/init.js") );
        onInitMainframeComponent(oComponent);

        //Set default values
        oComponent.addParamVal("name", _D("Dynamic")+" "+oComponent.UId);

        var aIcons = oComponent.getParamVal("icons");
        aIcons.push(blr.gfxResource.getIconByTypeName(0,"info"));

        oComponent.addParamVal("viewmodelist",[
            {id:0, label:"Classic"}
            //,{id:1, label:"Modal"}
            //,{id:2, label:"Only Text"}
            //,{id:3, label:"Hidden"}
        ]);

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");

        //GUI
        oComponent.addParamVal("gui/label","text");

        //EVE
        oComponent.addParamVal("eve/uid","");
    };
}
catch(err){
    console.error(err);
}
