/**
 * Created by blr on 16/10/15.
 */
try {
    // Init component \see data in component html
    function onInitComponent(data) {
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }

    // compones-mainframe.html callback
    function onGuiChangeGateway(sender, gateway, data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        return true;
    }

    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data) {
        onUpdate_protocol(data.protocol(), data);

        var oComponent = data.node();
        //Check
        if (!(oComponent instanceof Component)) {
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));

        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));

        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");

        //Set gateways
        var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;

            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){

                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cycle

                var oGateway = oNode.getData();                                                     //Get node data (gateway)

                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }


        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));

        //Set enable savelastvalue
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));

        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));

        //Set user visibility
        $Elem = $componentProperties.find("[eve-manager-id='uservisibility']");
        $Elem.prop("checked",oComponent.getParamVal("uservisibility"));


        //Set customData
        $Elem = $componentProperties.find("[eve-manager-id='customData']");
        // console.log(oComponent.getParamVal("customData"));
        $Elem.prop("value",oComponent.getParamVal("customData"));

        //Set tag
        //Set tags

        $Elem = $componentProperties.find("[eve-manager-id='tags']");
        var resTags = oComponent.getParamVal("tags");
        var $selectedTags="[";
        // console.log(resTags);
        if (resTags!="")
        {
            var res=resTags.split("|");

            for (var k=0;k<res.length;k++)
            {
                if ($selectedTags.length>1) $selectedTags+=",";
                $selectedTags+="{\"id\": \""+res[k]+"\", \"text\": \""+res[k]+"\"}";
            }

        }
        $selectedTags+="]";
        // console.log($selectedTags);
        $Elem.select2("data",jQuery.parseJSON( $selectedTags ));
        // console.log($Elem);

        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

        /** Ghost */
        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback"));

        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));
    }

    function onUpdate_mainframe(data) {
        var $Elem = undefined;
        return true;
    }

    function onUpdate_default(data) {
        return true;
    }

    function onUpdate_protocol(strProtocol, data) {
        switch (strProtocol) {
            default: {
                return onUpdate_default(data);
            }
        }
        return false;
    }

}catch(err){
    console.error(err);
}
