/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    function onInitComponent(oComponent){
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");

        onInitMainframeComponent(oComponent);
        
        //Set default values using Publish/Subscribe pattern
        oComponent.addParamVal("name",_D("Key pad")+" "+oComponent.UId);
        
        //Select default Gui gateway
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);
        
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();


        /** ABILITARE I COMMENTI PER AGIUNGERE ICONA
         *
         */
        var i0=model["instance"].skin.ComponentsInfo.keypad.defaultIcons[0];
        //var oIcon_status_1 = new Icon();
        var oPan = application.ResoucesManager.getIconsPanById(i0.panid);


        var panw=oPan.params.imgWidth;
        var panh=oPan.params.imgHeight;
        var iconw=oPan.params.iconsWidth;
        var iconh=oPan.params.iconsHeight;

        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: i0.panid,
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        
        //Important: maintain original position
        aIcons.push(oIcon_status_0);
        //aIcons.push(oIcon_status_1);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		//,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		//,{id:3, label:"Hidden"} 
        	]);

        // Components
        // BEGIN MUST BE ALWAYS EXIST
        console.log("Init Remote control item");
        oComponent.addParamVal("gui/components-list",[


        ]);
        oComponent.addParamVal("gui/components", new Array() );
        // END MUST BE ALWAYS EXIST

        oComponent.addParamVal("gui/Function","");
        oComponent.addParamVal("EVEUIStyle","onlyMap");

    }
}
catch(err){
    console.error(err);
}
