/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Set description
        $Elem = $componentProperties.find("[eve-manager-id='description']");
        $Elem.val(oComponent.getParamVal("description"));
    	
    	//Set cron
    	var aCron = oComponent.getParamVal("cron");
    	if(aCron instanceof Array){
    	    var aDates = new Array();
            
            //Parse years
            for(var k in aCron){
                //Parse month
                for(var h in aCron[k]){
                    var aCronLine = aCron[k][h].split(" ");
                    
                    //Set minutes
                    $componentProperties.find("[eve-manager-id='cron/minute']").val(aCronLine[0]);
                    //console.warn(aCronLine[0]);
                    
                    //Set hour
                    $componentProperties.find("[eve-manager-id='cron/hour']").val(aCronLine[1]);
                    //console.warn(aCronLine[1]);
                    
                    //Get day
                    var aDays = aCronLine[2].split(",");
                    for(var i=0; i<aDays.length; ++i){
                        aDates.push(new Date(k,h,aDays[i]));
                    }
                }
            }
            
            //Set Dates
            $componentProperties.find(".calendar").multiDatesPicker("option","addDates",aDays);
    	}
    	else{
    	    aCron = aCron.split(" ");
    	    
    	    //Set minutes
            $componentProperties.find("[eve-manager-id='cron/minute']").val(aCron[0]);
            //Set hour
            $componentProperties.find("[eve-manager-id='cron/hour']").val(aCron[1]);
            
            //Set day of month
            if(aCron[2] != "*"){
                var aDays = aCron[2].split(",");
                var $days = $componentProperties.find("[eve-manager-id='cron/monthly']");
                for(var k in aDays){
                    var intDay = parseInt(aDays[k],10) -1;
                    $($days[intDay]).prop("checked",true);
                }
            }
            
            //Set day of week
            if(aCron[4] != "*"){
                var aDays = aCron[4].split(",");
                var $days = $componentProperties.find("[eve-manager-id='cron/weekly']");
                for(var k in aDays){
                    var intDay = parseInt(aDays[k],10);
                    $($days[intDay]).prop("checked",true);
                }
            }
    	}
        
        
        //var date = new Date();
        //$componentProperties.find(".calendar").multiDatesPicker("option","addDates",[date.setDate(14), date.setDate(19)]);
        //addDates: [date.setDate(14), date.setDate(19)]
    	
    	//Set repetition
        $Elem = $componentProperties.find("[eve-manager-id='repetition']");
        var value = oComponent.getParamVal("repetition");
        $Elem.find("[value='"+ value +"']").prop("selected",true);
        setDropDown($Elem[0]);

        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );

        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));
    	
    };
}
catch(err){
    console.error(err);
}
