"use strict";

/*

    examples
 <span eve-manager-dictionary="Day Y text">Day Y text</span>:<br />
 <input type="text" eve-manager-type="parameter" eve-manager-id="gui/dayytext" onkeyup="setTextParam1(this);" on onkeypress="setTextParam1(this);"  />
 <span eve-manager-dictionary="Week Y text">Week Y text</span>:<br />
 <input type="text" eve-manager-type="parameter" eve-manager-id="gui/weekytext" onkeyup="setTextParam1(this);" on onkeypress="setTextParam1(this);"  />
 <span eve-manager-dictionary="Month Y text">Month Y text</span>:<br />
 <input type="text" eve-manager-type="parameter" eve-manager-id="gui/monthytext" onkeyup="setTextParam1(this);" on onkeypress="setTextParam1(this);"  />
 <span eve-manager-dictionary="Year Y text">Year Y text</span>:<br />
 <input type="text" eve-manager-type="parameter" eve-manager-id="gui/yearytext" onkeyup="setTextParam1(this);" on onkeypress="setTextParam1(this);"  />

 <input type="checkbox" eve-manager-type="parameter" eve-manager-id="gui/ssl" onkeyup="setTextParam1(this);" on onkeypress="setTextParam1(this);"  />
 <input type="checkbox" eve-manager-id="ghost/virtual-feedback" onchange="setFlags(this);" />


 */

function paramCheckBox(divPlace, data) {
    var self = this;

    var oComponent=application.getSelectComponent();
    var oData=oComponent.getData();


    if (oData.getParamVal(data.uid)==undefined)
        oData.addParamVal(data.uid,data.default);
    var $container = divPlace;

    var $label = $('<span eve-manager-dictionary="'+data.label+'">'+data.label+'</span><br><br>');
    var $input = $("<input type='checkbox'></input>");

    //Append input


    //$select.addClass("widget-components");
    $input.attr("eve-manager-id",data.uid);
    $input.attr("eve-manager-type","parameter");
    $input.attr("onchange","setFlags(this);");

    $container.append($input);
    $container.append($label);


    var val=oData.getParamVal(data.uid);
    if (val==true)
        $input.prop("checked", true );
    else
        $input.prop("checked", false );


    $($("[eve-manager-id='"+data.uid+"']")).change(function () {
        if (data.checkboxChangeCallBack!=undefined)
        {
            data.checkboxChangeCallBack(oData);
        }
    });

};